/* 
 * A desk accessory that inserts a vbl routine to delay for a while and
 * then fake a double click of the mouse.  This can be used to autostart
 * programs that expect the ST to be fully initialized (unlike the state
 * the ST is in when starting programs from the AUTO folder).  I tried this
 * as a program that I put in the AUTO folder but it didn't work. 
 *
 * Ron Janzen (ron@oscvax.UUCP)
 * Ontario Science Centre
 *
 * Link: accstart,dc,vbl,osbind,aesbind
 */

#include <portab.h>
#include <osbind.h>     

#ifdef VOID
#undef VOID
#endif
#define VOID	int

typedef struct KbdVectors {
    LONG midivec;	/* MIDI input */
    LONG vkbderr;	/* keyboard error */
    LONG vmiderr;	/* MIDI error */
    LONG statvec;	/* ikbd status packet */
    LONG mousevec;	/* mouse packet */
    LONG clockvec;	/* clock packet */
    LONG joyvec;	/* joystick packet */
    LONG midisys;	/* system MIDI vector */
    LONG ikbdsys;	/* system IKBD vector */
} KbdVectors;

#define NVBLS		*(WORD *)0x454
#define VBLQUEUE	*(LONG *)0x456

WORD VblEntry;		/* save the VBL entry that we used */
LONG *MouseVec;		/* address of vec->mousevec */

main()
{ 
    extern VOID insertVbl();
    extern VOID _Absorb();	/* absorb real mouse interrupts */
    extern LONG MousIntVec;	/* original mouse interrupt routine */

    KbdVectors *vec;		/* pointer to interrupt vectors */

    appl_init();

    /*
     * save the mouse interrupt vector so we can feed fake interrupts
     * into it. Also set it up so that real mouse interrupts are
     * ignored.
     */
    vec = (KbdVectors *)Kbdvbase();
    MousIntVec = vec->mousevec;
    MouseVec = &vec->mousevec;
    vec->mousevec = (LONG)_Absorb;

    /*
     * insert the routine that will generate the fake double click
     * into the vbl queue
     */
    Supexec( (LONG)insertVbl );

    /*
     * since desk accessories never die we have to do something
     */
    for (;;)
	evnt_timer( 30000, 0 );	/* wait 30 sec */
}

insertVbl()
{
    WORD vblIndex;
    LONG *vblQ;

    extern VOID _Vbl_int();	/* vbl routine to add */

    for ( vblIndex = 0, vblQ = VBLQUEUE; vblIndex < NVBLS; vblIndex++, vblQ++ )
	if ( *vblQ == 0L ) {
	    *vblQ = (LONG)_Vbl_int;
	    VblEntry = vblIndex;
	    break;
	}
}

/*
 * this routine is called from the VBL interrupt routine
 */
extractVbl()
{
    LONG *vblQ;

    extern LONG MousIntVec;

    vblQ = VBLQUEUE;
    vblQ[VblEntry] = 0L;

    *MouseVec = MousIntVec;	/* restore mouse interrupt vector */
}
