* 
* The VBL routine which waits for a while and then fakes a double
* click of the mouse.
*
* Ron Janzen (ron@oscvax.UUCP)
* Ontario Science Centre
*
* Register Usage:
* d0 - used to hold ClickCount
* d1 - used to hold DelayCount
* a0 - pointer to mouse packet as expected by mouse interrupt routine
* a1 - pointer to mouse interrupt vector
*

INIT_DELAY	equ	2*60	; initial delay
DOWNTIME	equ	5	; amt of time to hold button down
CLICKTIME	equ	5	; amt of time between clicks

	.globl	__Vbl_int
	.globl	__Absorb	; absorb real mouse interrupts
	.globl	_MousIntVec	; mouse interrupt vector

	.text

__Vbl_int:
	move.b	_ClickCount, d0
	bgt.s	delay
*
* if we have done the double click, extract ourselves from
* the VBL queue
*
	jmp	_extractVbl	; _extractVbl will do the reqd rts

delay:
	move.w	_DelayCount, d1
	beq.s	sendclick
	subq.w	#1, d1
	move.w	d1, _DelayCount
__Absorb:
	rts

sendclick:
	lea	_MPacket, a0
	btst.l	#0, d0		; is button going down or up
	beq.s	butDown
	move.b	#$f8, (a0)	; load mouse button up event
	move.w	#CLICKTIME, _DelayCount
	bra.s	sendit
butDown:
	move.b	#$fa, (a0)	; load mouse button down event
	move.w	#DOWNTIME, _DelayCount
sendit:
	subq.b	#1, d0
	move.b	d0, _ClickCount
	move.l	_MousIntVec, a1	; get mouse interrupt vector
	jmp	(a1)		; and jump there

	.data
	.even

_MousIntVec:	ds.l	1		; the mouse interrupt vector
_DelayCount:	dc.w	INIT_DELAY	; time to delay before fake outs
_ClickCount:	dc.b	4		; the number of up and down clicks
_MPacket:	dc.b	0,0,0		; the fake mouse packet
